#include <linux/fs.h>
#include <linux/iobuf.h>
#include <linux/major.h>
#include <linux/blkdev.h>
#include <linux/raw.h>
#include <asm/uaccess.h>
#include <linux/baio.h>

#define MAX_BLOCK_RAW 4

ssize_t	rw_raw_baio(int rw, struct baio_struct *bp, char *buf, 
		   size_t size, block_t block_nr, struct buffer_list *bl)
{
	struct kiobuf * iobuf;
	int		err;
	unsigned long	blocknr, blocks;
	unsigned long	b[MAX_BLOCK_RAW];
	int		iosize;
	int		i;
	kdev_t		dev;

	int		sector_size, sector_bits;
	
	sector_bits = 12 ;  //block size = 4096 bytes
	sector_size = 4096;

	dev = bp->inode->dev;

	err = alloc_kiovec(1, &iobuf);
	if (err)
		return err;

	/*
	 * Split the IO into KIO_MAX_SECTORS chunks, mapping and
	 * unmapping the single kiobuf as we go to perform each chunk of
	 * IO.  
	 */
	blocknr = block_nr * (bp->inode->sb->blocksize/sector_size);

	blocks = size >> sector_bits;
	iosize = blocks << sector_bits;
	
	err = map_user_kiobuf(rw, iobuf, (unsigned long) buf, iosize);
	if (err) {
		printk("\nmap_user_buffer failed");
		free_kiovec(1, &iobuf);
		return err;
	}
	
	for (i=0; i < blocks; i++)
 		b[i] = blocknr++;
	
	return brw_kiovec_baio(rw, bl, iobuf, dev, b, sector_size);
/*
	unmap_kiobuf(iobuf);

	free_kiovec(1, &iobuf);
	*/

}
