#include <stdio.h>
#include <iostream.h>
#include <malloc.h>
#include <sys/time.h>
#include <unistd.h>
#include <stdlib.h>

#include "tt.h"

#include <linux/baio.h>
#define BLOCKSIZE 4096
#define MAX_BAIO  128 
#define NOBUFFER 0x1

int	num_times;
long	delay;
int	range;

class Simulation {
	private:
		status_t st[MAX_BAIO];
		struct baio_entry **entry[MAX_BAIO];
		struct baio_desc desc[MAX_BAIO];
		int count;
		char **s[MAX_BAIO];

	public:
		Simulation();
		int start(int);
		int process(int);
};
		
				
Simulation :: Simulation ()
{
	status_t *dummy_st = new status_t;
	for(int i = 0; i< MAX_BAIO; i++) {
		entry[i] = (struct baio_entry**) malloc(2*sizeof(struct baio_entry*));
		entry[i][0] = (struct baio_entry*)malloc(sizeof(struct baio_entry));
		entry[i][1] = (struct baio_entry*)malloc(sizeof(struct baio_entry));
		s[i] = (char **)malloc(2*sizeof(char*));
		s[i][0] = (char*)malloc(BLOCKSIZE*3); //2 entries 
		s[i][1] = (char*)malloc(BLOCKSIZE*3); //2 entries
	
		s[i][0] += 4096 - (((long)s[i][0]) % 4096);
		s[i][1] += 4096 - (((long)s[i][1]) % 4096);

		memset(s[i][0], '#', BLOCKSIZE);
		memset(s[i][1], '#', BLOCKSIZE);
 
		entry[i][0]->data = s[i][0];
		entry[i][1]->data = s[i][1];
		entry[i][0]->status = dummy_st;
		entry[i][1]->status = dummy_st;
		entry[i][0]->op = entry[i][1]->op = BAIO_READ;

		desc[i].status = &st[i];
		desc[i].num_entries = 2;
		desc[i].entry = entry[i];
		desc[i].flags = NOBUFFER;
		//desc[i].flags = 0;
			
	}
}

int Simulation :: process(int index)
{
	for(long i=0; i<delay; i++)
		printf("");
}

			
int Simulation :: start(int num_iter)
{
	int bd, nr;
        int count = 0;	
	bd = open_dseg("/dev/hda6", "SIVA", 0);
	if (bd < 0) {
		cout <<"\nError opening disk segment! Simulation aborting.."<<endl;
		return -1;
	}

	init_baio();

	for(int i=0; i<MAX_BAIO; i++) {
		desc[i].blockfd = bd;
		int block = rand() % range;
		st[i] = IN_PROGRESS; 
		entry[i][0]->block_nr = block;
		entry[i][1]->block_nr = block + 1;
		baio(&desc[i]);
	}
	while(count < num_iter) {
		int i = (count) % MAX_BAIO;
		while (*(desc[i].status) != COMPLETE);
		st[i] = IN_PROGRESS;
		
		int block = rand() % range;
		entry[i][0]->block_nr = block;
		entry[i][1]->block_nr = block + 1;

		baio(&desc[i]);
		process(i);
		count ++ ;
	}	
	return 1;
}	
				
void main(int	argc, char	*argv[])
{
	
	Simulation sim;
	int i, nr;
	/*i = create_dseg("/dev/hda6", "SIVA", 100000, &nr);	
	printf("\ncreate_dseg returned act = %d\n", nr);*/

	struct timeval st_time, end_time, diff;

	if (argc != 4){
		printf("\nUsage: xyz <num_times> <range> <delay>\n");
		return;
	}

	if ((num_times = val(argv[1])) < 0){
		printf("num_times ???");
		return;
	}

	if ((range = val(argv[2])) < 0){
		printf("range ???");
		return;
	}


	if ((delay = val(argv[3])) < 0) {
		printf("delay ???");
		return;
	}

	printf("\nNum_times = %d, Range = %ld, Delay = %ld\n", num_times, range, delay);
	fflush(stdout);

	gettimeofday(&st_time, NULL);
	printf("\nStart time -> %lu : %lu",st_time.tv_sec,st_time.tv_usec);

	srand(st_time.tv_usec % 10000);
	//srand(2435);

	i = sim.start(num_times);
	if (i == 1)
		cout <<"\nSimulation completed successfully"<<endl;
	else
		cout <<"\nSimulation terminated abnormally"<<endl;
	
	gettimeofday(&end_time, NULL);
	printf("\nEnd time -> %lu : %lu",end_time.tv_sec,end_time.tv_usec);
	
	if (end_time.tv_usec < st_time.tv_usec) {
		diff.tv_usec = 1000000 + end_time.tv_usec - st_time.tv_usec;
		diff.tv_sec = end_time.tv_sec - st_time.tv_sec - 1;
	}
	else {
		diff.tv_sec = end_time.tv_sec - st_time.tv_sec;
		diff.tv_usec = end_time.tv_usec - st_time.tv_usec;
	}
	printf("\nDiffime -> %lu: %lu", diff.tv_sec, diff.tv_usec);
}
	

