#include <linux/aio.h>
#include <stdio.h>
#include <iostream.h>
#include <malloc.h>
#include <sys/time.h>
#include "/newfs/src/linux/include/asm/unistd.h"
#include <stdlib.h>
#include <fcntl.h>

#include "/root/final/tt.h"

#define BLOCKSIZE 4096
#define MAX_AIO 128 


int 	num_times;
long	delay;
long	range;

class Simulation {
	private:
		struct aiocb desc[MAX_AIO];
		char s[MAX_AIO][BLOCKSIZE*2 + 1024];
		int completed;

	public:
		Simulation();
		int start(int, int , int);
		int process(int);
};
		
				
Simulation :: Simulation ()
{
	completed = 0;
	for(int i = 0; i< MAX_AIO; i++) {
		desc[i].aio_reserved[3] = 0;
		desc[i].aio_buf = (long)s[i] + 512 - (((long)s[i]) % 512);
		memset(desc[i].aio_buf, 'q', 2*BLOCKSIZE);
		desc[i].aio_nbytes = BLOCKSIZE*2;
		desc[i].aio_offset = 0;
		desc[i].aio_lio_opcode = LIO_READ;
	}
}

int Simulation :: process(int index)
{
	for(long i=0; i<delay; i++)
		printf("");
}

			
int Simulation :: start(int num_times, int fd, int range)
{
	int nr;
        int count = 0;	
	
	for(int i=0; i<MAX_AIO; i++) {

		desc[i].aio_fildes = fd;
		nr = rand() % range;
		
		desc[i].aio_offset = nr * BLOCKSIZE;
		desc[i].aio_reserved[3] = 0;
		
		if (aio_read(&desc[i]) < 0){
			cout <<"\nError in aio"<<endl;
			return -1;
		}
	}
	
	while(count < num_times) {
		int i = (count) % MAX_AIO;
		while (desc[i].aio_reserved[3] == 0);
		desc[i].aio_reserved[3] = 0;
		
		int block = rand() % range;
		desc[i].aio_offset = block * BLOCKSIZE;

		if (aio_read(&desc[i]) < 0) {
			cout <<"\nError in aio"<<endl;
			return -1;
		}
		process(i);
		count ++ ;
	}	
	return 1;
}

main(int argc, char *argv[])
{
	Simulation sim;

	struct timeval st, et, diff;
	int fd = open("/dev/raw/raw11", O_RDWR);
	if (fd < 0) {
		perror("open");
		return -1;
	}

	if (argc != 4) {
	       printf("\nUsage: xyz <num_times> <range> <delay>");
       		return 1;
	}

	if ( (num_times = val(argv[1])) < 0) {
		printf("\nnum_times ??");
		return 1;
	}
	if ( (range = val(argv[2])) < 0) {
		printf("\nrange ??");
		return 1;
	}
	if ( (delay = val(argv[3])) < 0) {
		printf("\ndelay ??");
		return 1;
	}

	printf("\n Num_times = %d : Range = %ld : Delay = %ld",num_times, range, delay);
	fflush(stdout);

	gettimeofday(&st, NULL);
	cout <<"\nStart time -> "<< st.tv_sec <<": "<< st.tv_usec <<endl;

	srand(st.tv_usec % 10000);

	int i = sim.start(num_times, fd, range);
	if (i == 1)
		cout <<"\nSimulation completed successfully"<<endl;
	else
		cout <<"\nSimulation terminated abnormally"<<endl;
	sync();
	close(fd);
	gettimeofday(&et, NULL);

	cout <<"\nEnd time -> "<< et.tv_sec <<": "<< et.tv_usec <<endl;
	if (et.tv_usec < st.tv_usec) {
		diff.tv_usec = 1000000 + et.tv_usec - st.tv_usec;
		diff.tv_sec = et.tv_sec - st.tv_sec - 1;
	}
	else {
		diff.tv_sec = et.tv_sec - st.tv_sec;
		diff.tv_usec = et.tv_usec - st.tv_usec;
	}
	printf("\nDiffime -> %lu: %lu", diff.tv_sec, diff.tv_usec);

}
