#include <unistd.h>
#include <fcntl.h>
#include <sys/time.h>
#include <sys/types.h>
#include <stdio.h>

#include "tt.h"

#define BLOCKSIZE 4096

int	num_times;
long	delay;
long	range;


int	main(int argc, char *argv[])
{
	struct timeval st, et, diff;
	int fd = open("/dev/raw/raw11", O_RDWR);
	char *s;
	int i;
	long j;

	s = (char*)malloc(9000);
	s = (long)s + 512-((long)s % 512);

	if (fd < 0) {
		perror("open");
		return -1;
	}
	if (argc != 4) {
		printf("Usage: xyz <num_times> <range> <delay>");
		return 1;
	}

	if ((num_times = val(argv[1])) < 0) {
		printf("num_times ????");
		return 1;
	}
	
	if ((range = val(argv[2])) < 0) {
		printf("range ????");
		return 1;
	}
	
	if ((delay = val(argv[3])) < 0) {
		printf("delay");
		return 1;
	}

	printf("\nNum_times = %d, Range = %d Delay = %ld\n",num_times,range,delay);
	fflush(stdout);


	gettimeofday(&st, NULL);
	printf("\nStarttime -> %lu: %lu", st.tv_sec, st.tv_usec);

	//srand(2435);
	srand(st.tv_sec % 10000);
	fflush(stdout);
	for(i=0; i<num_times; i++) {
		int n;
		off_t off;
		int rnd = rand()% range ;
		//printf("\nrnd = %d", rnd);
		if ((off = lseek(fd, BLOCKSIZE*rnd, SEEK_SET) < 0)) {
			perror("lseek");
			return;
		}
		//printf("\nSeeking to %ld", off);
		
		n = read(fd, s, 2*BLOCKSIZE);

		if (n<0){
			printf("\nWrite failed");
			return;
		}
		//sync();
		for(j=0; j<delay; j++)
			printf("");
	}
	close(fd);
	//sync();
	gettimeofday(&et, NULL);
	printf("\nEndtime -> %lu: %lu", et.tv_sec, et.tv_usec);

	if (et.tv_usec < st.tv_usec) {
		diff.tv_usec = 1000000 + et.tv_usec - st.tv_usec;
		diff.tv_sec = et.tv_sec - st.tv_sec - 1;
	}
	else {
		diff.tv_sec = et.tv_sec - st.tv_sec;
		diff.tv_usec = et.tv_usec - st.tv_usec;
	}
	printf("\nDiffime -> %lu: %lu", diff.tv_sec, diff.tv_usec);


}
		
			

	
