#include <unistd.h>
#include <fcntl.h>
#include <sys/time.h>
#include <stdio.h>
#define BLOCKSIZE 4096

#include "tt.h"

int	num_times;
long	delay;

int	main(int argc, char *argv[])
{
	struct timeval st, et, diff;
	int fd = open("/dev/raw/raw11", O_RDWR);
	char *s;
	int i;
	long j;

	if ( fd < 0) {
		perror("open");
		return 1;
	}
	
	s = (char*)malloc(9000);
	s += 512 - (((long)s)% 512);
	if (argc != 3) {
		printf("Usage: xyz <num_times> <delay>");
		return 1;
	}

	if ((num_times = val(argv[1])) < 0) {
		printf("num_times ????");
		return 1;
	}
	
	if ((delay = val(argv[2])) < 0) {
		printf("delay");
		return 1;
	}

	printf("\nNum_times = %d, Delay = %d\n",num_times,delay);
	fflush(stdout);


	gettimeofday(&st, NULL);
	printf("\nStarttime -> %lu: %lu", st.tv_sec, st.tv_usec);
	fflush(stdout);
	
	for(i=0; i<num_times; i++) {
		int n = read(fd, s, 2*BLOCKSIZE);
		if (n<0){
			printf("\nREad failed");
			return;
		}
		for(j=0; j<delay; j++)
			printf("");
	}
	close(fd);
	
	gettimeofday(&et, NULL);
	printf("\nEndtime -> %lu: %lu", et.tv_sec, et.tv_usec);

	if (et.tv_usec < st.tv_usec) {
		diff.tv_usec = 1000000 + et.tv_usec - st.tv_usec;
		diff.tv_sec = et.tv_sec - st.tv_sec - 1;
	}
	else {
		diff.tv_sec = et.tv_sec - st.tv_sec;
		diff.tv_usec = et.tv_usec - st.tv_usec;
	}
	printf("\nDiffime -> %lu: %lu", diff.tv_sec, diff.tv_usec);


}
		
			

	
